#include <M5Stack.h>
#include <Wire.h>
#include <WiFi.h>
#include <WiFiUDP.h>
#define FACES_KEYBOARD_I2C_ADDR 0x08

static WiFiUDP udp; 
static const int rport = 9000; //送信先のポート
static const int lport = 7000;  //自身のポート
String str="";
String lip="";
String msg="";
int lmsg=7;
int lptr=0;
int rp[]={192,168,0,0};
String rip="";
char ripc[50];
int setM=0;

void drawLcd(String s) {
  M5.Lcd.clear();
  M5.Lcd.setTextSize(2);
  M5.Lcd.setTextColor(TFT_YELLOW,TFT_BLACK);
  M5.Lcd.setCursor(0,0); M5.Lcd.print("< M5 Keyboard Controller >");
  M5.Lcd.setCursor(0,20); M5.Lcd.print("My IP:"+lip);
  M5.Lcd.setCursor(0,40); M5.Lcd.print("Setting Mode:"+String(setM));
  rip=String(rp[0])+"."+String(rp[1])+"."+String(rp[2])+"."+String(rp[3]);
  M5.Lcd.setCursor(0,60); M5.Lcd.print("RcvIP:"+rip);
  M5.Lcd.setCursor(0,100); M5.Lcd.print(s);
}

void setup() {
  M5.begin();
  Wire.begin();
  M5.Lcd.clear();
  M5.Lcd.setTextSize(2);
  M5.Lcd.setTextColor(TFT_YELLOW,TFT_BLACK);
  M5.Lcd.setCursor(0,0); M5.Lcd.print("< M5 Keboard Controller >");
  M5.Lcd.setCursor(0,40); M5.Lcd.print("Home WiFi  : Press Btn A");
  M5.Lcd.setCursor(0,60); M5.Lcd.print("Mobile WiFi: Press Btn B");
  const char* ssid;
  const char* password;
  while (1){
    if (M5.BtnA.wasPressed()){
      lip="192.168.64.xx";
      rp[0]=192; rp[1]=168; rp[2]=64; rp[3]=40;
      ssid = "**********";      // 無線LANアクセスポイントのSSID
      password = "**********";  // パスワード
      M5.Lcd.setCursor(0,100); M5.Lcd.print("Home WiFi was Selected");
      break;
    } else if(M5.BtnB.wasPressed()){
      lip="192.168.100.xx";
      rp[0]=192; rp[1]=168; rp[2]=100; rp[3]=100;
      ssid = "SPWN_H36_401C4D";
      password = "9r0tqd61mj0h8fn";
      M5.Lcd.setCursor(0,100); M5.Lcd.print("Mobile WiFi was Selected");
      break;
    }
    M5.update();
    delay(100);
  }
  WiFi.mode(WIFI_STA);                    // 無線LANをSTAモードに設定
  WiFi.begin(ssid,password);              // 無線LANアクセスポイントへ接続
  while(WiFi.status() != WL_CONNECTED){   // 接続に成功するまで待つ
    delay(500);                           // 待ち時間処理
  }  

  lip=WiFi.localIP().toString();

  while(1){
    if(M5.BtnA.wasPressed()){
      ++setM; if (setM>4) setM=0;
      drawLcd("");
    } else if (M5.BtnB.wasPressed() && setM<4 && rp[setM]>0 ){
      --rp[setM]; drawLcd("");
    } else if (M5.BtnC.wasPressed() && setM<4 && rp[setM]<255){
      ++rp[setM]; drawLcd("");
    } else if (setM==4 && (M5.BtnB.wasPressed() || M5.BtnC.wasPressed())){
      break;
    }
    M5.update();
    delay(100);
  }
  rip.toCharArray(ripc,50);
  delay(100);
  udp.begin(rport);
  msg="Ready!";
  drawLcd(msg);
}

void loop() {
  Wire.requestFrom(FACES_KEYBOARD_I2C_ADDR, 1);
  int c;
  while (Wire.available()) {
    c = Wire.read(); // receive a byte as character
    int nled=-1;
    if (c=='A') {nled=0; msg="C4";}
    else if(c=='M') {nled=1; msg="D4";}
    else if(c=='%') {nled=2; msg="E4";}
    else if(c=='/') {nled=3; msg="F4";}
    
    else if(c=='7') {nled=4; msg="G4";} 
    else if(c=='8') {nled=5; msg="A4";}
    else if(c=='9') {nled=6; msg="B4";}
    else if(c=='*') {nled=7; msg="C5";}

    else if(c=='4') {nled=8; msg="D5";} 
    else if(c=='5') {nled=9; msg="E5";}
    else if(c=='6') {nled=10; msg="F5";}
    else if(c=='-') {nled=11; msg="G5";}
    
    else if(c=='1') {nled=12; msg="A5";} 
    else if(c=='2') {nled=13; msg="B5";}
    else if(c=='3') {nled=14; msg="C6";}
    else if(c=='+') {nled=15; msg="D6";}
    
    else if(c=='.') {nled=16; msg="Demo";}
    else if(c=='0') {nled=17; msg="-";}
    else if(c=='`') {nled=18; msg="+";}
    else if(c=='=') {nled=19; msg="=";}
    
    if (nled>=0){
      udp.beginPacket(ripc,rport);  // 送信パケットの開始
      udp.write(c);                 // 送信メッセージを送信
      udp.endPacket();              // 送信パケットの終了
      delay(50);
      drawLcd(msg);
    }
    delay(50);
  }
}
